// считать и вывести баланс///
boolean getbalance () {
   // Загрузить ключ.
  for (byte i = 0; i < 6; i++) 
      key.keyByte[i] = 0xFF;
  // Аутентификация 
  status = mfrc522.PCD_Authenticate(MFRC522::PICC_CMD_MF_AUTH_KEY_A, 4, &key, &(mfrc522.uid)); 
  if (status == MFRC522::STATUS_OK) {
      Serial.print(F("Authentication ok! "));
  }
  Serial.println(mfrc522.GetStatusCodeName(status));
  // Считать данные из блока 5.
  status = mfrc522.MIFARE_Read(block, buffer1, &len);
  if (status == MFRC522::STATUS_OK) {
     Serial.println(mfrc522.GetStatusCodeName(status));
     Serial.print(F("Reading OK! "));
     // распечатать данные сектора
     for (uint8_t i = 0; i < 16; i++) {
        Serial.print(buffer1[i],HEX);Serial.print(" ");
     }
     Serial.println(" ");         
     // вывод баланса 
     balance=(buffer1[2]<<8)+buffer1[3];
     Serial.println(balance);
     // Вывод баланса карты на экран.
     lcd_balanse (balance);
     delay(2000);
     return true;
  }
  return false;
}
// добавить баланс на карту //
boolean addbalance (int newbalance) {
  // 
  lcd.setCursor(0,1); 
  lcd.print("                ");
  lcd.setCursor(0,1); 
  lcd.print("Loading ... ");
  //
  
  byte trailerBlock   = 7;
  // изменить баланс//
    buffer1[2]=highByte(newbalance);
    buffer1[3]=lowByte(newbalance);
    Serial.print ("new balance=");Serial.println (newbalance);
     // Authenticate using key B
    Serial.println(F("Authenticating again using key B..."));
    status = (MFRC522::StatusCode) mfrc522.PCD_Authenticate(MFRC522::PICC_CMD_MF_AUTH_KEY_B, trailerBlock, &key, &(mfrc522.uid));
    if (status != MFRC522::STATUS_OK) {
        Serial.print(F("PCD_Authenticate() false: "));
        return false;
    }
    Serial.println(mfrc522.GetStatusCodeName(status));
    
    // Write data to the block
    Serial.print(F("Writing data into block ")); Serial.print(block);
    Serial.println(F(" ..."));
    status = (MFRC522::StatusCode) mfrc522.MIFARE_Write(block, buffer1, 16);
    if (status == MFRC522::STATUS_OK) {
        Serial.print(F("MIFARE_Write() ok: "));
        return true;
    }
    Serial.println(mfrc522.GetStatusCodeName(status));
    Serial.println();
    return false; 
}
    
// проверить на наличие в сестеме данных.
boolean isstrangekarta(){
   // Загрузить ключ.
  for (byte i = 0; i < 6; i++) 
      key.keyByte[i] = 0xFF;
  // Аутентификация 
  status = mfrc522.PCD_Authenticate(MFRC522::PICC_CMD_MF_AUTH_KEY_A, 4, &key, &(mfrc522.uid)); 
  if (status == MFRC522::STATUS_OK) {
      Serial.print(F("Authentication ok! "));
  }
  Serial.println(mfrc522.GetStatusCodeName(status));
  // Считать данные из блока 5.
  status = mfrc522.MIFARE_Read(block, buffer1, &len);
  if (status == MFRC522::STATUS_OK) {
     Serial.println(mfrc522.GetStatusCodeName(status));
     Serial.print(F("Reading OK! "));
     // распечатать данные сектора
     for (uint8_t i = 0; i < 16; i++) {
        Serial.print(buffer1[i],HEX);Serial.print(" ");
     }
     Serial.println(" ");         
     // проверка карты в системе.
     if(buffer1[4]==cardKod[0] 
        && buffer1[5]==cardKod[1] 
        && buffer1[6]==cardKod[2] 
        && buffer1[7]==cardKod[3]){
        return true;
     }
  }
  return false;

}
// сделать карту системной (записать 0x33,0x35,0x37,0x39)
void setkartanostrange(){
   // Загрузить ключ.
  for (byte i = 0; i < 6; i++) 
      key.keyByte[i] = 0xFF;
  // Аутентификация 
  status = mfrc522.PCD_Authenticate(MFRC522::PICC_CMD_MF_AUTH_KEY_A, 4, &key, &(mfrc522.uid)); 
  if (status == MFRC522::STATUS_OK) {
      Serial.print(F("Authentication ok! "));
  }
  Serial.println(mfrc522.GetStatusCodeName(status));
  // Считать данные из блока 5.
  status = mfrc522.MIFARE_Read(block, buffer1, &len);
  if (status == MFRC522::STATUS_OK) {
     Serial.println(mfrc522.GetStatusCodeName(status));
     Serial.print(F("Reading OK! "));
     // распечатать данные сектора
     for (uint8_t i = 0; i < 16; i++) {
        Serial.print(buffer1[i],HEX);Serial.print(" ");
     }
     Serial.println(" ");         
     // записать 0x33,0x35,0x37,0x39 в буфер
     buffer1[4]=cardKod[0]; 
     buffer1[5]=cardKod[1]; 
     buffer1[6]=cardKod[2];
     buffer1[7]=cardKod[3];

     for (uint8_t i = 0; i < 16; i++) {
        Serial.print(buffer1[i],HEX);Serial.print(" ");
     }
    byte trailerBlock = 7;
    // изменить баланс//
    buffer1[0]=0;
    buffer1[1]=0;
    buffer1[2]=0;
    buffer1[3]=0;
     for (uint8_t i = 0; i < 16; i++) {
        Serial.print(buffer1[i],HEX);Serial.print(" ");
     }
    Serial.print ("set balance=");Serial.println (0);
     // Authenticate using key B
    Serial.println(F("Authenticating again using key B..."));
    status = (MFRC522::StatusCode) mfrc522.PCD_Authenticate(MFRC522::PICC_CMD_MF_AUTH_KEY_B, trailerBlock, &key, &(mfrc522.uid));
    if (status == MFRC522::STATUS_OK) {
        Serial.print(F("PCD_Authenticate() ok: "));
    }
    Serial.println(mfrc522.GetStatusCodeName(status));
    
    // Write data to the block
    Serial.print(F("Writing data into block ")); Serial.print(block);
    Serial.println(F(" ..."));
    status = (MFRC522::StatusCode) mfrc522.MIFARE_Write(block, buffer1, 16);
    if (status == MFRC522::STATUS_OK) {
        Serial.print(F("MIFARE_Write() ok: "));
    }
    Serial.println(mfrc522.GetStatusCodeName(status));
    Serial.println();
    return; 
  
   }  
}

